      MODULE athenadefs
! 
! AUTHORS:
!     James M. Stone, Princeton Univeristy
!     Thomas Gardiner, University of Maryland
!     Peter J. Teuben, University of Maryland
!     John Hawley, University of Virginia
!
!     This software was produced with support from NSF Grant AST-0113571 
!
! Copyright 2003 James M. Stone, Thomas Gardiner,
!                Peter Teuben, John F. Hawley
!
!   This program is free software; you can redistribute it and/or modify
!   it under the terms of the GNU General Public License as published by
!   the Free Software Foundation.
!
!   This program is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU General Public License for more details.
!

      IMPLICIT NONE
      integer, parameter :: real4  = selected_real_kind(6,37)
      integer, parameter :: real8  = selected_real_kind(15,307)

! The user's choice between real and double is made here
      integer, parameter :: r_kind=real8

! The user's choice of basic physics is made through logical variables

      logical :: adiabatic 
      logical :: mhd 
 
! Number of ghost zones to use
      integer, parameter :: NGHOST = 2

      real (r_kind), parameter    :: TINY_NUMBER = TINY(1._r_kind)
      real (r_kind), parameter    :: TWO_THIRDS = 2./3.

      real (r_kind) :: ISOTHERMAL_C


      TYPE grid
         real (r_kind), dimension(:), pointer :: d
         real (r_kind), dimension(:), pointer :: e
         real (r_kind), dimension(:), pointer :: m1
         real (r_kind), dimension(:), pointer :: m2
         real (r_kind), dimension(:), pointer :: m3
         real (r_kind), dimension(:), pointer :: b1
         real (r_kind), dimension(:), pointer :: b2
         real (r_kind), dimension(:), pointer :: b3
         real (r_kind), dimension(:), pointer :: x1
         real (r_kind) ::  gamma
         real (r_kind) ::  x1_0
         real (r_kind) ::  dx
         real (r_kind) ::  dt, time
         integer :: nx1, is, ie
         integer :: ibc_x1, obc_x1
      END TYPE grid

      COMMON / EOS / ISOTHERMAL_C, adiabatic, mhd

      END MODULE athenadefs
