
SUBROUTINE problem(agrid)
!
! Initialize user defined problems
! This version is the sod shock tube
!
use athenadefs
IMPLICIT NONE
type (grid) agrid

real (r_kind) :: gamma, dl, pl, v1l, v2l, v3l
real (r_kind) :: dr, pr, v1r, v2r, v3r

integer :: i, is, ie, nx1, nhalf
real (r_kind) :: dx

namelist /prob/ gamma, dl, pl, v1l, v2l, v3l &
                     , dr, pr, v1r, v2r, v3r
!------------------------------------------------------------------------
! Test to make sure right version of code is compiled
! for this test problem
!
if (mhd .or. (adiabatic)) then
   write(*,*) 'Isothermal Sod shock tube is an isothermal hydro problem'
   write(*,*) 'Current code is MHD = ', MHD
   write(*,*) ' ADIABATIC = ', ADIABATIC
endif

open(unit=12, file='athena.input',status='OLD')
read(12,nml=PROB)
close(12)

nx1 = agrid%nx1
is = NGHOST+1
ie = nx1-NGHOST
agrid%is = is
agrid%ie = ie
dx = agrid%dx
nhalf = (ie-is+1)/2
agrid%x1(is) = agrid%x1_0+0.5*dx
do i=1,NGHOST
  agrid%x1(is-i) = agrid%x1(is-i+1)-dx
end do
do i=is+1,nx1
  agrid%x1(i) = agrid%x1(i-1)+dx
end do

ISOTHERMAL_C =  1.

agrid%d(1:nhalf) = dl
agrid%d(nhalf+1:nx1) = dr
agrid%m1(1:nhalf) = dl*v1l
agrid%m1(nhalf+1:nx1) = dr*v1r
agrid%m2(1:nhalf) = dl*v2l
agrid%m2(nhalf+1:nx1) = dr*v2r
agrid%m3(1:nhalf) = dl*v3l
agrid%m3(nhalf+1:nx1) = dr*v3r


return

END SUBROUTINE problem
