
SUBROUTINE problem(agrid)
!
! Initialize user defined problems
! This version is the sod shock tube
!
use athenadefs
IMPLICIT NONE
type (grid) agrid

real (r_kind) :: gamma, dl, pl, v1l, v2l, v3l
real (r_kind) :: dr, pr, v1r, v2r, v3r

integer :: i, is, ie, nx1, nhalf
real (r_kind) :: dx

namelist /prob/ gamma, dl, pl, v1l, v2l, v3l &
                     , dr, pr, v1r, v2r, v3r
!------------------------------------------------------------------------
! Test to make sure right version of code is compiled
! for this test problem
!
if (mhd .or. (.not. adiabatic)) then
   write(*,*) 'Sod shock tube is an adiabatic hydro problem'
   write(*,*) 'Current code is MHD = ', MHD
   write(*,*) ' ADIABATIC = ', ADIABATIC
endif

open(unit=12, file='athena.input',status='OLD')
read(12,nml=PROB)
close(12)

nx1 = agrid%nx1
is = NGHOST+1
ie = nx1-NGHOST
agrid%is = is
agrid%ie = ie
dx = agrid%dx
nhalf = is + (ie-is+1)/2 -1 
agrid%x1(is) = agrid%x1_0
do i=1,NGHOST
  agrid%x1(is-i) = agrid%x1(is-i+1)-dx
end do
do i=is+1,nx1
  agrid%x1(i) = agrid%x1(i-1)+dx
end do

write(*,*) 'gamma = ', gamma

agrid%gamma = gamma
agrid%d(1:nhalf) = dl
agrid%d(nhalf+1:nx1) = dr
agrid%e(1:nhalf) = pl/(gamma-1._r_kind) &
     + 0.5_r_kind*(v1l*v1l + v2l*v2l + v3l*v3l)*dl
agrid%e(nhalf+1:nx1) = pr/(gamma-1._r_kind) &
     + 0.5_r_kind*(v1r*v1r + v2r*v2r + v3r*v3r)*dr
agrid%m1(1:nhalf) = dl*v1l
agrid%m1(nhalf+1:nx1) = dr*v1r
agrid%m2(1:nhalf) = dl*v2l
agrid%m2(nhalf+1:nx1) = dr*v2r
agrid%m3(1:nhalf) = dl*v3l
agrid%m3(nhalf+1:nx1) = dr*v3r

return

END SUBROUTINE problem
